﻿using System.Collections;
// Note: this code is simplified from...
// http://blog.thekieners.com/2010/02/07/databinding-multi-series-charts/
// It is *not* my work.
using System.Windows;
using System.Windows.Controls.DataVisualization.Charting;

namespace XmlTestApp
{
  // Note: this code is simplified from...
  // http://blog.thekieners.com/2010/02/07/databinding-multi-series-charts/
  // It is *not* my work.
  public class MultiChart : Chart
  {
    #region SeriesSource (DependencyProperty)

    public IEnumerable SeriesSource
    {
      get { return (IEnumerable)GetValue(SeriesSourceProperty); }
      set { SetValue(SeriesSourceProperty, value); }
    }
    public static readonly DependencyProperty SeriesSourceProperty = DependencyProperty.Register("SeriesSource", typeof(IEnumerable), typeof(MultiChart), new PropertyMetadata(default(IEnumerable), new PropertyChangedCallback(OnSeriesSourceChanged)));

    private static void OnSeriesSourceChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
    {
      IEnumerable oldValue = (IEnumerable)e.OldValue;
      IEnumerable newValue = (IEnumerable)e.NewValue;
      MultiChart source = (MultiChart)d;
      source.OnSeriesSourceChanged(oldValue, newValue);
    }

    protected virtual void OnSeriesSourceChanged(IEnumerable oldValue, IEnumerable newValue)
    {
      this.Series.Clear();

      if (newValue != null)
      {
        foreach (object item in newValue)
        {
          DataTemplate dataTemplate = null;

          // get data template
          if (dataTemplate == null && this.SeriesTemplate != null)
          {
            dataTemplate = this.SeriesTemplate;
          }

          // load data template content
          if (dataTemplate != null)
          {
            Series series = dataTemplate.LoadContent() as Series;

            if (series != null)
            {
              // set data context
              series.DataContext = item;

              this.Series.Add(series);
            }
          }
        }
      }

      // TODO Listen for INotifyCollectionChanged with a weak event pattern
    }

    #endregion

    #region SeriesTemplate (DependencyProperty)

    public DataTemplate SeriesTemplate
    {
      get { return (DataTemplate)GetValue(SeriesTemplateProperty); }
      set { SetValue(SeriesTemplateProperty, value); }
    }
    public static readonly DependencyProperty SeriesTemplateProperty = DependencyProperty.Register("SeriesTemplate", typeof(DataTemplate), typeof(MultiChart), new PropertyMetadata(default(DataTemplate)));

    #endregion

  }
}
